export path=($path $HOME/.config/dotfiles/bin)
export fpath=($fpath $ZDOTDIR/local/fpath)
export FZF_MARKS_FILE=$HOME/.config/fzfmarks

mkdir -p $HOME/.cache/zsh

declare -A ZINIT
ZINIT[BIN_DIR]="$HOME/.config/zinit/bin"
ZINIT[HOME_DIR]="$HOME/.config/zinit"
ZINIT[ZCOMPDUMP_PATH]="$HOME/.cache/zsh/compdump"

source $HOME/.config/zinit/bin/zinit.zsh

# Theme
export STARSHIP_CONFIG=$ZDOTDIR/starship.toml
eval "$(starship init zsh)"

zinit silent wait'1' blockf for zsh-users/zsh-completions
zinit silent wait'1' atload"_zsh_autosuggest_start" for zsh-users/zsh-autosuggestions

# Needed
source $ZDOTDIR/files/dircolor.zsh
source $ZDOTDIR/files/aliases.zsh
source $ZDOTDIR/files/completion.zsh
source $ZDOTDIR/files/history.zsh
source $ZDOTDIR/files/direnv.zsh
zinit snippet OMZL::functions.zsh
zinit snippet OMZL::directories.zsh
zinit snippet OMZL::key-bindings.zsh
zinit snippet OMZL::termsupport.zsh
zinit snippet OMZL::clipboard.zsh
zinit snippet OMZL::grep.zsh
zinit snippet OMZP::sudo
zinit snippet OMZP::command-not-found
zinit snippet OMZP::fzf
zinit snippet OMZP::lando

eval "$(fasd --init auto)"
zinit silent wait'1' light-mode for wookayin/fzf-fasd
zinit silent wait'1' light-mode for urbainvaes/fzf-marks
zinit silent wait'1' light-mode for voronkovich/gitignore.plugin.zsh
zinit silent wait'1' light-mode for reegnz/jq-zsh-plugin
zinit silent wait'1' light-mode for @asdf-vm/asdf
zinit silent wait'1' light-mode for Aloxaf/fzf-tab

# syntax highlighting
zinit silent wait'1' atinit"zpcompinit; zpcdreplay -q" for zsh-users/zsh-syntax-highlighting

# Local RC
[[ -f "$ZDOTDIR/local/rc.zsh" ]] && source "$ZDOTDIR/local/rc.zsh"
